using System;
using System.Collections;
using System.Data.SqlTypes;
using System.IO;
using System.Net;
using System.Text;

public partial class UserDefinedFunctions
{

    private class ConsultaCotacao
    {

        public SqlDateTime Data;
        public SqlDouble Cotacao;
        
        public ConsultaCotacao(SqlDateTime data, SqlDouble cotacao)
        {

            Data = data;
            Cotacao = cotacao;
            
        }

    }


    [Microsoft.SqlServer.Server.SqlFunction(
        FillRowMethodName = "FillRow_ConsultaCotacao",
        TableDefinition = "Dt_Cotacao DATETIME, Vl_Cotacao FLOAT"
    )]
    public static IEnumerable fncConverteMoedaHistoricoRange(string token, string moedaOrigem, string moedaDestino, SqlDateTime dataInicio, SqlDateTime dataFim)
    {

        var consultaCotacaoCollection = new ArrayList();

        var url = "https://free.currconv.com/api/v7/convert?q=" + moedaOrigem + "_" + moedaDestino + "&compact=ultra&date=" + dataInicio.Value.ToString("yyyy-MM-dd") + "&endDate=" + dataFim.Value.ToString("yyyy-MM-dd") + "&apiKey=" + token;
        var request = (HttpWebRequest)WebRequest.Create(url);

        request.Method = "GET";
        request.ContentType = "application/json";
        var resposta = "";

        using (var response = (HttpWebResponse)request.GetResponse())
        {
            using (var stream = response.GetResponseStream())
            {
                if (stream != null)
                {
                    using (var streamReader = new StreamReader(stream, Encoding.GetEncoding("UTF-8")))
                    {

                        resposta = streamReader.ReadToEnd();

                        if (resposta.IndexOf("error", StringComparison.InvariantCultureIgnoreCase) >= 0)
                        {

                            consultaCotacaoCollection.Add(new ConsultaCotacao(
                                SqlDateTime.Null,
                                -1
                            ));

                            return consultaCotacaoCollection;

                        }

                        resposta = resposta.Replace("{", "").Replace("}", "").Replace("\"", "");
                        resposta = resposta.Substring(resposta.IndexOf(":") + 1);

                        var varLinhas = resposta.Split(',');
                        var numLinhas = varLinhas.Length;

                        for(var i = 0; i < numLinhas; i++)
                        {

                            var linha = varLinhas[i];
                            var palavras = linha.Split(':');

                            consultaCotacaoCollection.Add(new ConsultaCotacao(
                                Convert.ToDateTime(palavras[0]),
                                Convert.ToDouble(palavras[1])
                            ));

                        }

                    }
                }
            }
        }

        return consultaCotacaoCollection;

    }


    protected static void FillRow_ConsultaCotacao(object objConsultaCotacao, out SqlDateTime data, out SqlDouble cotacao)
    {

        var consultaCotacao = (ConsultaCotacao) objConsultaCotacao;

        data = consultaCotacao.Data;
        cotacao = consultaCotacao.Cotacao;

    }

}
